;
;   afxctrl2.ahk: Helper library for AutoHotkey to control Afx without custom key configuration
;
;       Copyright (c) Yak! 2007-2008 All rights reserved.
;
;   $URL: https://yak.myhome.cx/repos/source/afxscrpt/trunk/afxctrl2.ahk $
;   $Date: 2009-10-11 23:03:39 +0900 (Sun, 11 Oct 2009) $
;   $Rev: 928 $
;

#Include afxctrl.ahk

_AfxRegisterOnMessage(wParam,lParam,msg,hwnd)
{
	static callback
	If(msg=0) {
		callback:=wParam
	} Else If(msg = 0x8000 || msg = 0x8004 || msg = 0x8005) {
; LB_GETCARETINDEX or LB_SETCARETINDEX or WM_DESTROY
		%callback%(0,0,msg,hwnd,wParam)
	} Else If(msg = 0x8001) { ; WM_MOVE
		%callback%(lParam,0,msg,hwnd,wParam)
	} Else If(msg = 0x8002 || msg = 0x8003) { ; WM_SIZE or WM_ACTIVATE
		VarSetCapacity(atom, 256)
		result:=DllCall("GlobalGetAtomName", "UShort", lParam, "Str", atom, "Int", 256, "UInt")
		StringSplit, param, atom, "|"
		DllCall("GlobalDeleteAtom", "UShort", lParam, "UShort")
		%callback%(param1,param2,msg,hwnd,wParam)
	}
}

AfxRegisterOnMessage(callback)
{
	hwnd := _GetApplicationWindow()
	_LoadInjEnvDLL()
	DllCall("injenv.dll\InstallInjectEnvHook")
	DllCall("injenv.dll\RegisterAfxOnMessage", "UInt", hwnd)
	_AfxRegisterOnMessage(callback,0,0,0) ; Register callback
	OnMessage(0x8000, "_AfxRegisterOnMessage")
	OnMessage(0x8001, "_AfxRegisterOnMessage")
	OnMessage(0x8002, "_AfxRegisterOnMessage")
	OnMessage(0x8003, "_AfxRegisterOnMessage")
	OnMessage(0x8004, "_AfxRegisterOnMessage")
	OnMessage(0x8005, "_AfxRegisterOnMessage")
}

AfxUnregisterOnMessage()
{
	hwnd := _GetApplicationWindow()
	OnMessage(0x8000, "")
	OnMessage(0x8001, "")
	OnMessage(0x8002, "")
	OnMessage(0x8003, "")
	OnMessage(0x8004, "")
	OnMessage(0x8005, "")
	DllCall("injenv.dll\UnregisterAfxOnMessage", "UInt", hwnd)
	DllCall("injenv.dll\UninstallInjectEnvHook")
	_UnloadInjEnvDLL()
}
